package com.qnapcomm.myapplication;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.Toast;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import static android.os.Environment.DIRECTORY_DOWNLOADS;

public class LocalList extends Activity {
    private ListView lvLocal;

    private Intent mIntent;
    private Bundle mBundle;

    private int mParentRequestCode;
    private String mUploadFile;
    private long mUploadSize;
    private List<String> localFiles = new ArrayList<String>();

    public ProgressDialog progDlg = null;

    private static final int sMsgGetLocalList = 1;
    private static final int sMsgErrorList = 2;

    public Handler uiMessageHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case sMsgGetLocalList:
                    progDlg.dismiss();
                    lvLocal.setAdapter(new ArrayAdapter<String>(LocalList.this, android.R.layout.simple_list_item_1, localFiles));
                    lvLocal.invalidate();
                    break;
                case sMsgErrorList:
                    progDlg.dismiss();
                    Toast.makeText(LocalList.this, "get list error", Toast.LENGTH_SHORT).show();
                    break;
            }
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.local_list);

        mUploadFile = "";
        mUploadSize = 0;

        mIntent = getIntent();
        mBundle = mIntent.getExtras();
        mParentRequestCode = mBundle.getInt("requestCode");

        CharSequence strDlgTitle = getString(R.string.progdlg_title);
        CharSequence strDlgBody = getString(R.string.progdlg_body_loading);

        progDlg = new ProgressDialog(LocalList.this);
        progDlg.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        progDlg.setTitle(strDlgTitle);
        progDlg.setMessage(strDlgBody);
        progDlg.show();

        Thread thread = new Thread() {
            @Override
            public void run() {
                File downloadFolder = Environment.getExternalStoragePublicDirectory(DIRECTORY_DOWNLOADS);
                File[] files = downloadFolder.listFiles();

                Message msg = new Message();
                if (files != null)
                {
                    for(int i = 0; i < files.length; i++)
                    {
                        File file = files[i];
                        localFiles.add(file.getName());
                    }
                    msg.what = sMsgGetLocalList;
                } else {
                    msg.what = sMsgErrorList;
                }

                uiMessageHandler.sendMessage(msg);
            }
        };
        thread.start();

        lvLocal = (ListView) findViewById(R.id.lvLocal);
        lvLocal.setChoiceMode(ListView.CHOICE_MODE_NONE);
        lvLocal.setOnItemLongClickListener(new AdapterView.OnItemLongClickListener() {

            @Override
            public boolean onItemLongClick(AdapterView<?> a, View v, int pos, long id)
            {
                String uploadFileName = localFiles.get(pos);
                File downloadFolder = Environment.getExternalStoragePublicDirectory(DIRECTORY_DOWNLOADS);
                mUploadFile = downloadFolder.getPath() +File.separator +  uploadFileName;
                File f = new File(mUploadFile);
                mUploadSize = f.length();

                finish();
                return false;
            }
        });
    }

    @Override
    public void finish() {
        mBundle.putString("uploadFile", mUploadFile);
        mBundle.putLong("uploadSize", mUploadSize);
        mIntent.putExtras(mBundle);
        setResult(mParentRequestCode, mIntent);
        super.finish();
    }
}
